<template>
  <v-card class="pt-4">
    <v-card-text>
      <v-form ref="form" @submit.prevent="validarFormulario">
        <v-text-field
          v-model="formProducto.stock"
          label="Stock de Productos"
          hint="Ingrese la cantidad de productos nuevos"
          autofocus
          type="number"
          :rules="rules.nombre"
          required
          color="accent"
        />
      </v-form>
    </v-card-text>

    <v-card-actions :class="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'">
      <v-btn class="elevation-2 font-weight-light" @click="cerrarDialog()">
        Cerrar
      </v-btn>
      <v-spacer />
      <v-btn class="elevation-2 font-weight-light accent" @click="validarFormulario">
        Agregar
      </v-btn>
    </v-card-actions>
  </v-card>
</template>

<script lang="ts">
import { Component, Prop, Ref, Vue } from 'vue-property-decorator'
import AppToast from '~/core/utils/AppToast'
import { AppStore } from '~/store/AppStore'
import { Producto } from '~/core/models/producto'
import { ProductosStore } from '~/store/ProductosStore'

    @Component
export default class formRenovarStock extends Vue {
        @Ref('form') formulario;
        @Prop({ default: null }) producto!:Producto;

        formProducto:Producto = {
          stock: null
        };

        rules = {
          nombre: [
            v => !!v || 'Campo requerido'
          ]
        };

        mounted () {
        }

        cerrarDialog () {
          this.$emit('onClose')
        }

        validarFormulario () {
          if (this.formulario.validate()) {
            this.renovarStock()
          } else {
            AppToast.error('Campos inválidos')
          }
        }

        private async renovarStock () {
          AppStore.SHOW_LOADING('Renovando Stock')
          this.producto.stock = Number(this.producto.stock) + Number(this.formProducto.stock)
          try {
            await ProductosStore.modificarProducto(this.producto)
            AppToast.success('Stock renovado')
          } catch (e) {
          }
          AppStore.HIDE_LOADING()
        }
}
</script>

<style lang="scss">

</style>
